﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Web.Infrastructure.DynamicModuleHelper;
using System.Reflection;
using System.ServiceModel;

[assembly: PreApplicationStartMethod(typeof(WcfService1.Startup), "Init")]

namespace WcfService1
{
    public static class Startup
    {
        public static void Init()
        {
            try
            {
                // Invoke the "EnsureInitialized" method so we can register our service right now.
                // I know, this is a risky move, but is simpler than other solutions.
                // Seems to work so this method doesn't have dependencies on other stuff.
                // Other solutions might be: 
                //      *- Create a "Startup" normal WCF service and hook the OnStart method to do this.
                //          This would work only under AppFabric where AutoStart is enabled for all services.
                //          (and I have to test it, is just an idea)
                //      *- set a timer here to try to initialize this in some way, hoping that the ServiceHostingEnvironment
                //          class gets initialized somehow, even is nobody have made an Http request.

                DynamicServiceHelper.EnsureInitialized();

                // Now, we register our service
                DynamicServiceHelper.RegisterService("~/Service3.svc", typeof(WcfService3.Service3Factory), typeof(WcfService3.Service3));
            }
            catch { } // log the exeption here if something failed.

            // If we cannot register our service here because the class ServiceHostingEnvironment is 
            // not yet initialized, we can inject our HttpModule that will 
            // in turn register our service (after some Http request is received).

            DynamicModuleUtility.RegisterModule(typeof(ServiceModule));
        }
    }
}